/*
 * HostInterface.c
 *
 *  Created on: Aug 13, 2009
 *      Author: chwolfe2
 */

#include "HostInterface.h"
#include <stdio.h>
#include <string.h>

int issueShellCommand(char * command, char* result, size_t resultSizeLimit){
	if (command==NULL || result==NULL || resultSizeLimit==0) return -1;
	FILE *pipedOutput = popen(command, "r");
	size_t count=0;
	if (pipedOutput){
		while (!feof(pipedOutput)){
			result[count]=fgetc ( pipedOutput );
			if (result[count]==EOF) {
				result[count]=0;
				break;
			}
			count++;
			if (count == resultSizeLimit-1){
				while (!feof(pipedOutput)) fgetc ( pipedOutput ); // dump any remaining characters
			}
		}
	}
	result[count]='\0';
	return pclose(pipedOutput);

}
StatusCode ShellGetNumber(char * command, size_t* number){
	char buffer[2048];
		if (issueShellCommand(command, buffer, 2048) == -1) {
			return FAILURE;
		}
		if (strlen(buffer)==0){
			return FAILURE;
		}
		*number=strtoul(buffer,NULL,10);
		return SUCCESS;
}

StatusCode ShellGetString(char * command, char* result, size_t resultSizeLimit){
	if (issueShellCommand(command, result, resultSizeLimit) == -1)
		return FAILURE;
	else
		return SUCCESS;
}



