#ifndef SOCKET_H_
#define SOCKET_H_
#include	<sys/socket.h>
#include	<netinet/in.h>

class Socket{
private:
	int 				inboundSocketHandle;
	sockaddr_in 		inboundAddress;
	sockaddr_in 		inboundSourceAddress;
	socklen_t			inboundSourceAddressSize;
	unsigned short		inboundport;
	bool				inboundIsOpen;
	int 				outboundSocketHandle;
	sockaddr_in 		outboundAddress;
	unsigned short		outboundport;
	bool				outboundIsOpen;
	size_t  			_LifetimeBytesSent;
	size_t 				_LifetimeBytesReceived;

public:
	Socket();
	virtual ~Socket();
	bool		inboundConnectionIsOpen();
	bool		outboundConnectionIsOpen();
	void		closeInbound();
	void		closeOutbound();
	void	openInbound(unsigned short port);
	void	openOutbound(const char * hostIP, unsigned short port);
	size_t	send(char* data, size_t length);
	size_t	receive(char* data, size_t maxLength);
	size_t  getBytesSent();
	size_t  getBytesReceived();
}; 

#endif /*SOCKET_H_*/
