/*
 * Config.c
 *
 *  Created on: Nov 1, 2009
 *      Author: chwolfe2
 */

#include "DataFormats.h"
#include "Persistence.h"
#include "Config.h"
#include <assert.h>
#include <string.h>
#include <stdio.h>


Database configDb;
boolean isConfigOpen=false;


void Config_Close(){
	if (isConfigOpen){
		Persistence_Close(&configDb);
		isConfigOpen=false;
	}
}

StatusCode Config_Initialize(boolean reloadConfig){
	if (!isConfigOpen){
		//printf("%s\n",(reloadConfig?"true":"false"));
		if (!reloadConfig){
			StatusCode sc = Persistence_Open(&configDb,CONFIGFILENAME);
			if (sc!=SUCCESS){
				sc = Persistence_Create(CONFIGFILENAME,CONFIGDEFAULTSFILENAME);
				if (sc!=SUCCESS){
					return sc;
				} else {
					sc=Persistence_Open(&configDb,CONFIGFILENAME);
					if (sc==SUCCESS){
						atexit(Config_Close);
						isConfigOpen=true;
					}
					return sc;
				}
			} else {
				atexit(Config_Close);
				isConfigOpen=true;
				return sc;
			}
		} else {
			StatusCode sc = Persistence_Create(CONFIGFILENAME,CONFIGDEFAULTSFILENAME);
			if (sc!=SUCCESS){
				return sc;
			} else {
				sc=Persistence_Open(&configDb,CONFIGFILENAME);
				if (sc==SUCCESS){
					atexit(Config_Close);
					isConfigOpen=true;
				}
				return sc;
			}
		}
	} else {
		return FAILURE;
	}
}

StatusCode Config_Get(char * param, char * result){
	assert(isConfigOpen);
	assert (param!=NULL &&  result!=NULL);
	return Persistence_Get_String(&configDb,param,result);
}

StatusCode Config_Set		 (char * param, char * value){
	assert(isConfigOpen);
	assert (param!=NULL &&  value!=NULL);
	return Persistence_Set_String(&configDb,param,value);
}

StatusCode Config_Finalize(){
	Config_Close();
	return SUCCESS;
}
