/*
 * HostInterface.h
 *
 *  Created on: Aug 13, 2009
 *      Author: chwolfe2
 */

#ifndef HOSTINTERFACE_H_
#define HOSTINTERFACE_H_
#include <stdlib.h>
#include <stdio.h>

#include "Defines.h"
typedef struct __ProcessHandle{
	FILE*  fHandle;
	char*  resultBuffer;
	size_t resultSizeMax;
	size_t resultSize;
	int    keepOutput; // do we record what the process dumps to stdout?
}ProcessHandle;

int issueShellCommand(char * command, char* result, size_t resultSizeLimit);
StatusCode ShellGetNumber(char * command, size_t* number);
StatusCode ShellGetString(char * command, char* result, size_t resultSizeLimit);

StatusCode  LaunchProcess(const char* command, int keepOutput, size_t resultSizeLimit, char * result, ProcessHandle** ph);
StatusCode  ReleaseProcessHandle(ProcessHandle* ph);
StatusCode  CheckProcessDone(ProcessHandle* ph);


#endif /* HOSTINTERFACE_H_ */
