/*
 * MessageQueue.h
 *
 *  Created on: Oct 18, 2009
 *      Author: chwolfe2
 */

#ifndef MESSAGEQUEUE_H_
#define MESSAGEQUEUE_H_
#include    <mqueue.h>
#include "Defines.h"
#include "Message.h"

#define DEFAULT_QUEUE_SIZE 10

typedef struct __MessageQueue{
  mqd_t          handle;
  struct mq_attr attributes;
  char *         name;
} MessageQueue;


StatusCode MessageQueue_Create(MessageQueue* msgQ, char* name);
StatusCode MessageQueue_Destroy(MessageQueue* msgQ);
StatusCode MessageQueue_Enqueue(MessageQueue* msgQ, BaseMessage* msg);
StatusCode MessageQueue_Dequeue(MessageQueue* msgQ, BaseMessage* msg);

#endif /* MESSAGEQUEUE_H_ */
