/*
 * Socket.h
 *
 *  Created on: Oct 18, 2009
 *      Author: chwolfe2
 */

#ifndef SOCKET_H_
#define SOCKET_H_
#include "Defines.h"
#include	<sys/socket.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<sys/select.h>
#include	<netinet/in.h>
#include 	<arpa/inet.h>
#include 	<netdb.h>

typedef struct __Socket{
  int              Handle;
  struct sockaddr_in    Address;
  struct sockaddr_in    SourceAddress;
  socklen_t        		SourceAddressSize;
  struct hostent * 		host;				// only used for outbound sockets
  size_t 				bytes;     			// sent or received total
  size_t 				packets;   			// sent or received total
} Socket;
#define SocketSize sizeof(Socket)


StatusCode Socket_Create(Socket* s);
StatusCode Socket_Destroy(Socket* s);
StatusCode Socket_OpenRecieve(Socket* s, unsigned short port);
StatusCode Socket_OpenSend(Socket* s, char* destinationURL, unsigned short port);
StatusCode Socket_Close(Socket* s);
StatusCode Socket_Recieve(Socket* s, char* buffer, size_t* size);
StatusCode Socket_Send(Socket* s, char* buffer, size_t size);




#endif /* SOCKET_H_ */
